<?php
/**
 * Plugin Name:             QuadMenu PRO
 * Plugin URI:              https://quadmenu.com
 * Description:             The Best WordPress Mega Menu Plugin
 * Version:                 3.0.4
 * Text Domain:             quadmenu-pro
 * Author:                  20script
 * Author URI:              https://www.20script.ir
 * License:                 Copyright
 * Domain Path:             /languages
 * Request at least:        4.7.0
 * Tested up to:            6.2
 * Requires PHP:            5.6
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

define( 'QUADMENU_PRO_DB_KEY', '_menu_item_quadmenu' );
define( 'QUADMENU_PRO_PLUGIN_NAME', 'QuadMenu PRO' );
define( 'QUADMENU_PRO_PLUGIN_VERSION', '3.0.4' );
define( 'QUADMENU_PRO_PLUGIN_FILE', __FILE__ );
define( 'QUADMENU_PRO_PLUGIN_DIR', __DIR__ . DIRECTORY_SEPARATOR );
define( 'QUADMENU__PRO_PLUGIN_URL', plugin_dir_url( QUADMENU_PRO_PLUGIN_FILE ) );
define( 'QUADMENU_PRO_DEMO_URL', 'https://quadmenu.com/?utm_source=quadmenu_admin' );
define( 'QUADMENU_PRO_LICENSES_URL', 'https://quadmenu.com/account/licenses/?utm_source=quadmenu_admin' );
define( 'QUADMENU_PRO_SUPPORT_URL', 'https://quadmenu.com/account/support/?utm_source=quadmenu_admin' );
define( 'QUADMENU_PRO_ACTIVATE_URL', admin_url( 'admin.php?page=quadmenu_welcome_license' ) );
define( 'QUADMENU_FREE_PLUGIN_NAME', 'QuadMenu' );

/**
 * Load composer autoload.
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Load composer packages.
 */
require_once __DIR__ . '/vendor_packages/wp-i18n-map.php';
require_once __DIR__ . '/vendor_packages/wp-dashboard-widget-news.php';
require_once __DIR__ . '/vendor_packages/wp-license-client.php';
require_once __DIR__ . '/vendor_packages/wp-notice-plugin-required.php';
require_once __DIR__ . '/vendor_packages/wp-plugin-table-links.php';
/**
 * Load plugin classes
 */
require_once __DIR__ . '/lib/class-plugin.php';
/**
 * Plugin activation hook
 */
register_activation_hook(
	__FILE__,
	function() {
		do_action( 'quadmenu_pro__activation' );
	}
);

/**
 * Plugin activation hook
 */
register_deactivation_hook(
	__FILE__,
	function() {
		do_action( 'quadmenu_pro__deactivation' );
	}
);
